//+------------------------------------------------------------------+
//|                                                     difilt34.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Copyright  2009, iraj."
#property link      "http://www.gheymatha.com"


//#property indicator_chart_window
#property indicator_separate_window
#property stacksize   65536
#property indicator_buffers 1
#property indicator_color1 Red
//---- input parameters
extern double    wn=0.01 ;
extern int limit=1000;
double pi=3.141592653589793;
//---- buffers
double w[];
double vdif[];
double vdifilt[];
double v_difilt[];
double vdifiltinv[];
double h[];
double uu[];
double BarCloseValuesinv[];
double BarCloseValues[];
double BarCloseValues_dif[];
double BCV[];
double bBuffer[];
int length_bBuffer;
double ExtMapBuffer1[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
    
   
   ArrayResize(BCV,limit);
   ArrayResize(BarCloseValuesinv,limit);
   ArrayResize(BarCloseValues,limit);
   ArrayResize(BarCloseValues_dif,limit-1);
   ArrayResize(bBuffer,limit-1);
   ArrayResize(w,2*limit-3);
   ArrayResize(uu,2*limit-3);
   ArrayResize(v_difilt,limit-1);
   ArrayResize(h,limit);
   ArrayResize(vdifiltinv,limit);
   ArrayResize(vdifilt,limit);
   
   for(int j=0;j<(limit-1);j++)
     {
          bBuffer[j]=wn*sinc(wn*j);
     }
     length_bBuffer=limit-1;
     
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  double sinc(double t)
   {
      if (t==0) 
         return(1);
      else
         return(MathSin(pi*t)/(pi*t));
   }
 
          
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if(Bars<=limit) return(0);
   //------------- 
   ArrayCopySeries(BCV,MODE_CLOSE,Symbol(),0); 
   ArrayCopy(BarCloseValuesinv,BCV,0,0,limit);
   int length_BarCloseValuesinv=ArraySize(BarCloseValuesinv);
   for(int l=0;l<length_BarCloseValuesinv;l++)
   {
      BarCloseValues[l]=BarCloseValuesinv[length_BarCloseValuesinv-1-l];
   }
   
   int length_BarCloseValues=ArraySize(BarCloseValues);
   for(int i=0;i<length_BarCloseValues-1;i++)
      {
         BarCloseValues_dif[i]=BarCloseValues[i+1]-BarCloseValues[i];
      }
     int length_BarCloseValues_dif=ArraySize(BarCloseValues_dif);
     ArrayInitialize(w,0);
     for(int k=0;k<=(length_bBuffer+length_BarCloseValues_dif-2);k++)
      {
         for(int e=MathMax(0,k+1-length_bBuffer);e<=MathMin(k,length_BarCloseValues_dif-1);e++) 
            w[k]=w[k]+BarCloseValues_dif[e]*bBuffer[k-e];
      }
    
     ArrayInitialize(uu,0);
     ArrayCopy(uu,w,0,0,WHOLE_ARRAY);
       
     for(int s=0;s<=length_BarCloseValues_dif-1;s++)
      {
        v_difilt[s]=uu[s]; 
      }
       
      
     int length_v_difilt=ArraySize(v_difilt); 
      
     h[0]=BarCloseValues[0];
     double hh=BarCloseValues[0];
     for(int t=0;t<=length_v_difilt-1;t++) 
     {
      hh=hh+v_difilt[t];
      h[t+1]=hh;
     }
     for(int f=0;f<length_BarCloseValues;f++)
     {
       vdifiltinv[f]=h[f];
     }
      
         
   int length_vdifiltinv=ArraySize(vdifiltinv);
     for(int y=0;y<length_vdifiltinv;y++)
   {
      vdifilt[y]=vdifiltinv[length_vdifiltinv-1-y];
   }
   ArrayCopy(ExtMapBuffer1,vdifilt,0,0,WHOLE_ARRAY);
  
  return(0);
  }

